<template>
  <div>
    <v-table density="compact" hover>
      <thead>
        <tr>
          <th>first name</th><th>last name</th><th>email</th><th>pesel</th><th>roles</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(user, index) in users" :key="index" @click="editedUser = user">
          <td>{{ user.firstName }}</td><td>{{ user.lastName }}</td><td>{{ user.email }}</td><td>{{ user.pesel }}</td>
          <td>
            <v-chip v-for="(roleName, rindex) in ['admin', 'user']" :key="rindex" size="x-small" :color="user.roles.includes(rindex) ? 'success' : 'default'">{{ roleName }}</v-chip>
          </td>
        </tr>
      </tbody>
    </v-table>
  </div>
  <v-btn variant="elevated" color="success" @click="editedUser = true">Add user</v-btn>
  <EditUser @hideEditUser="closeEditUser" :show="editedUser"/>
</template>

<script>
import axios from 'axios'

import EditUser from './EditUser.vue'

export default {
  name: 'Users',
  inheritAttrs: false,
  components: { EditUser },
  methods: {
    closeEditUser(payload) {
      if(payload) this.users = payload
      this.editedUser = false
    }
  },
  data() {
    return {
      users: [],
      editedUser: false
    }
  },
  mounted() {
    axios.get('/user').then(
        (res) => { this.users = res.data }
      ).catch(
        (err) => { console.error(err.message) }
      )
  }
}
</script>

<style scoped>
</style>